/* Copyright(C) 2011 Cobac.Net All rights reserved. */

module REG16(
    /* AvalonoX */
    input           CLK, RST,
    input   [1:0]   ADDR,
    input           WRITE, READ,
    input   [15:0]  WRDATA,
    input   [1:0]   BYTEEN,
    output  reg [15:0]  RDDATA
);

/*  */
reg [15:0]   reg0; // WX^0

always @( posedge CLK, posedge RST ) begin
    if ( RST )
        reg0 <= 16'h0;
    else if ( WRITE & ADDR==2'b00 ) begin
        if ( BYTEEN[0] )
            reg0[7:0]  <= WRDATA[7:0];
        if ( BYTEEN[1] )
            reg0[15:8] <= WRDATA[15:8];
    end
end

reg [15:0]   reg1; // WX^1

always @( posedge CLK, posedge RST ) begin
    if ( RST )
        reg1 <= 16'h0;
    else if ( WRITE & ADDR==2'b01 ) begin
        if ( BYTEEN[0] )
            reg1[7:0]  <= WRDATA[7:0];
        if ( BYTEEN[1] )
            reg1[15:8] <= WRDATA[15:8];
    end
end

reg [15:0]   reg2; // WX^2

always @( posedge CLK, posedge RST ) begin
    if ( RST )
        reg2 <= 16'h0;
    else if ( WRITE & ADDR==2'b10 ) begin
        if ( BYTEEN[0] )
            reg2[7:0]  <= WRDATA[7:0];
        if ( BYTEEN[1] )
            reg2[15:8] <= WRDATA[15:8];
    end
end

reg [15:0]   reg3; // WX^3

always @( posedge CLK, posedge RST ) begin
    if ( RST )
        reg3 <= 16'h0;
    else if ( WRITE & ADDR==2'b11 ) begin
        if ( BYTEEN[0] )
            reg3[7:0]  <= WRDATA[7:0];
        if ( BYTEEN[1] )
            reg3[15:8] <= WRDATA[15:8];
    end
end

/* ǂݏo */
always @* begin
    if ( READ )
        case ( ADDR )
            2'b00: RDDATA <= reg0;
            2'b01: RDDATA <= reg1;
            2'b10: RDDATA <= reg2;
            2'b11: RDDATA <= reg3;
        endcase
    else
        RDDATA <= 16'h0;
end

endmodule
