#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

#define DEVFILE "/dev/leddev"

int open_file(char *filename)
{
    int fd;

    fd = open(filename, O_RDWR);
    if (fd == -1) {
        perror("open");
    }
    return (fd);
}


void close_file(int fd)
{
    if (close(fd) != 0) {
        perror("close");
    }
}


void write_data(int fd, unsigned char val)
{
    ssize_t ret;

    ret = write(fd, &val, 1);
    if (ret <= 0) {
        perror("write");
    }
}


int main(int argc, char *argv[])
{
    volatile int i, j, out;
    volatile unsigned char val = 1;

    int fd;
    
    printf("*** PIO LED TEST ***\n");

    fd = open_file(DEVFILE);
    
    if (fd == -1) {
        printf("Error! Aborted.\n");
        return 0;
    }

    for ( i=0; i<16; i++ ) {
        switch ( i ) {
            case 0x0: out = 0xc0; break;
            case 0x1: out = 0xf9; break;
            case 0x2: out = 0xa4; break;
            case 0x3: out = 0xb0; break;
            case 0x4: out = 0x99; break;
            case 0x5: out = 0x92; break;
            case 0x6: out = 0x82; break;
            case 0x7: out = 0xd8; break;
            case 0x8: out = 0x80; break;
            case 0x9: out = 0x90; break;
            case 0xA: out = 0x88; break;
            case 0xB: out = 0x83; break;
            case 0xC: out = 0xc6; break;
            case 0xD: out = 0xa1; break;
            case 0xE: out = 0x86; break;
            case 0xF: out = 0x8e; break;
            default:  out = 0xff; break;
        }
        write_data(fd, out);
        for ( j=0; j<500000; j++ );
    }

    close_file(fd);

    return 0;
}
